/* USER CODE BEGIN Header */
/**
 *
 * By: www.emcu.eu
 * Year: 2020
 *
 * Based on NUCLEO-F030R8
 *
 * Example that show how to use:
 * 		TIM4 for generate a PWM at 50% duty cycle.
 * 		UART2 for redirect printf and get character in interrupt mode.
 *
 * For more explanation see:
 *
 *
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2020 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include <stdio.h>

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

#define Year 20
#define Version 2
#define TRUE 1
#define FALSE 0

/*
#define  PERIOD_VALUE       (uint32_t)(666 - 1)  		// Period Value
#define  PULSE1_VALUE       (uint32_t)(PERIOD_VALUE/2)  // Capture Compare 1 Value
*/

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
TIM_HandleTypeDef htim14;

UART_HandleTypeDef huart2;

/* USER CODE BEGIN PV */

uint8_t MemKey = 1;
uint8_t RxData=FALSE;
uint8_t CharDataBuffer[10];

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_USART2_UART_Init(void);
static void MX_TIM14_Init(void);
/* USER CODE BEGIN PFP */

static void OUR_TIM14_Init(uint16_t Prescaler, uint16_t Period, uint16_t Pulse);
void ChangePWM(uint8_t Val);
void ExplanationMessages(void);

/* Timer Output Compare Configuration Structure declaration */
// TIM_OC_InitTypeDef sConfig;

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_USART2_UART_Init();
  MX_TIM14_Init();
  /* USER CODE BEGIN 2 */

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */

  //
  // Enable Timer (TIM14) for generate PWM (on PA4)
  //
  HAL_TIM_PWM_Start(&htim14, TIM_CHANNEL_1);

  //
  // Enable the USART2 in RX mode under Interrupt
  //
  HAL_UART_Receive_IT(&huart2, CharDataBuffer, 1);

  //
  // Explanation messages
  //
  ExplanationMessages();
  printf("     Now the PWM frequency is 1 Hz and (50%% duty cycle)  \n\r\n\r");

  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */

	  //
	  // Test the Blue Button status
	  //
	  if ((HAL_GPIO_ReadPin(GPIOC, GPIO_PIN_13)) == GPIO_PIN_RESET) // KEY1 ==> PRESSED
	  {
		  HAL_Delay(10); // mS delay for debounce
		  if ((HAL_GPIO_ReadPin(GPIOC, GPIO_PIN_13)) == GPIO_PIN_RESET) // KEY1 ==> PRESSED
		  {

			  if (MemKey == 1)
				  ChangePWM(MemKey);
			  if (MemKey == 2)
				  ChangePWM(MemKey);
			  if (MemKey == 3)
				  ChangePWM(MemKey);
			  if (MemKey == 4)
				  ChangePWM(MemKey);
			  if (MemKey == 5)
				  ChangePWM(MemKey);
			  if (MemKey == 6)
				  ChangePWM(MemKey);
			  if (MemKey == 7)
				  ChangePWM(MemKey);

			  // Waiting the release of Blue Button
			  while (HAL_GPIO_ReadPin(GPIOC, GPIO_PIN_13) != GPIO_PIN_SET);
			  HAL_Delay(500); // mS delay

			  MemKey++;
			  if (MemKey > 7)
				  MemKey = 1;
		  }

	  }

	  //
	  // Show the last character received via USART2 and if it is a command it executes it
	  // See also below the: HAL_UART_RxCpltCallback
	  //
	  if (RxData==TRUE)
	  {
		  printf(" ... Last character received (via USART2) is: -> %c <- \n\r", CharDataBuffer[0]);

		  if ((CharDataBuffer[0]) == '+')
		  {
			  MemKey++;
			  if (MemKey > 7)
			  {
				  MemKey = 7;
				  printf(" *** ATTENTION: max frequency reached, please use - for decrease the frequency. \n\r");
			  }
			  ChangePWM(MemKey);
		  }

		  if ((CharDataBuffer[0]) == '-')
		  {
			  MemKey--;
			  if (MemKey < 1)
			  {
				  MemKey = 1;
				  printf(" *** ATTENTION: min frequency reached, please use + for increase the frequency. \n\r");
			  }
			  ChangePWM(MemKey);
		  }

		  if ((CharDataBuffer[0]) == '?')
		  {
			  ExplanationMessages();
		  }

		  RxData=FALSE;
	  }
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.HSICalibrationValue = RCC_HSICALIBRATION_DEFAULT;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSI;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL12;
  RCC_OscInitStruct.PLL.PREDIV = RCC_PREDIV_DIV1;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV8;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_1) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief TIM14 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM14_Init(void)
{

  /* USER CODE BEGIN TIM14_Init 0 */

  /* USER CODE END TIM14_Init 0 */

  TIM_OC_InitTypeDef sConfigOC = {0};

  /* USER CODE BEGIN TIM14_Init 1 */

  /* USER CODE END TIM14_Init 1 */
  htim14.Instance = TIM14;
  htim14.Init.Prescaler = 199;
  htim14.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim14.Init.Period = 59999;
  htim14.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim14.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_DISABLE;
  if (HAL_TIM_Base_Init(&htim14) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_TIM_PWM_Init(&htim14) != HAL_OK)
  {
    Error_Handler();
  }
  sConfigOC.OCMode = TIM_OCMODE_PWM1;
  sConfigOC.Pulse = 30000;
  sConfigOC.OCPolarity = TIM_OCPOLARITY_HIGH;
  sConfigOC.OCFastMode = TIM_OCFAST_DISABLE;
  if (HAL_TIM_PWM_ConfigChannel(&htim14, &sConfigOC, TIM_CHANNEL_1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM14_Init 2 */

  /* USER CODE END TIM14_Init 2 */
  HAL_TIM_MspPostInit(&htim14);

}

/**
  * @brief USART2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART2_UART_Init(void)
{

  /* USER CODE BEGIN USART2_Init 0 */

  /* USER CODE END USART2_Init 0 */

  /* USER CODE BEGIN USART2_Init 1 */

  /* USER CODE END USART2_Init 1 */
  huart2.Instance = USART2;
  huart2.Init.BaudRate = 115200;
  huart2.Init.WordLength = UART_WORDLENGTH_8B;
  huart2.Init.StopBits = UART_STOPBITS_1;
  huart2.Init.Parity = UART_PARITY_NONE;
  huart2.Init.Mode = UART_MODE_TX_RX;
  huart2.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart2.Init.OverSampling = UART_OVERSAMPLING_16;
  huart2.Init.OneBitSampling = UART_ONE_BIT_SAMPLE_DISABLE;
  huart2.AdvancedInit.AdvFeatureInit = UART_ADVFEATURE_NO_INIT;
  if (HAL_UART_Init(&huart2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART2_Init 2 */

  /* USER CODE END USART2_Init 2 */

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOF_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(LD2_GPIO_Port, LD2_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin : B1_Pin */
  GPIO_InitStruct.Pin = B1_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_IT_FALLING;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(B1_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pin : LD2_Pin */
  GPIO_InitStruct.Pin = LD2_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(LD2_GPIO_Port, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */

void ExplanationMessages(void)
{
	  printf("\n\r\n\r By: www.emcu.eu - Ver_%d - Year:20%d\n\r", Version, Year);
	  printf(" USART2 for redirect printf and receive in Interrupt mode \n\r");
	  printf(" plus TIM14 in PWM output to the pin PA4 (Arduino A2 on connector CN8) \n\r");
	  printf(" Press the Blue Button of symbol + or - on the Tera Term emulator, \n\r");
	  printf(" for change the frequency of the PWM generated. \n\r");
	  printf("      There are some frequency presetting that are:\n\r");
	  printf("            1 .... Hz \n\r");
	  printf("            10 ... Hz \n\r");
	  printf("            100 .. Hz \n\r");
	  printf("            1 .... KHz \n\r");
	  printf("            10 ... KHz \n\r");
	  printf("            20 ... KHz \n\r");
	  printf("            40 ... KHz \n\r");
	  printf(" Press the symbol ? for see again the explanations. \n\r\n\r");
}

void ChangePWM(uint8_t Val)
{
	  if (Val == 1)
	  {
		  printf(" ... New PWM frequency is 1 Hz (50%% duty cycle) \n\r");
		  OUR_TIM14_Init(199, 59999, 30000);
		  //
		  // Enable Timer (TIM14) for generate PWM (on PA4)
		  //
		  HAL_TIM_PWM_Start(&htim14, TIM_CHANNEL_1);
	  }

	  if (Val == 2)
	  {
		  printf(" ... New PWM frequency is 10 Hz (50%% duty cycle) \n\r");
		  OUR_TIM14_Init(199, 5999, 3000);
		  //
		  // Enable Timer (TIM14) for generate PWM (on PA4)
		  //
		  HAL_TIM_PWM_Start(&htim14, TIM_CHANNEL_1);
	  }

	  if (Val == 3)
	  {
		  printf(" ... New PWM frequency is 100 Hz (50%% duty cycle) \n\r");
		  OUR_TIM14_Init(199, 599, 300);
		  //
		  // Enable Timer (TIM14) for generate PWM (on PA4)
		  //
		  HAL_TIM_PWM_Start(&htim14, TIM_CHANNEL_1);
	  }

	  if (Val == 4)
	  {
		  printf(" ... New PWM frequency is 1 KHz (50%% duty cycle) \n\r");
		  OUR_TIM14_Init(199, 59, 30);
		  //
		  // Enable Timer (TIM14) for generate PWM (on PA4)
		  //
		  HAL_TIM_PWM_Start(&htim14, TIM_CHANNEL_1);
	  }

	  if (Val == 5)
	  {
		  printf(" ... New PWM frequency is 10 KHz (50%% duty cycle) \n\r");
		  OUR_TIM14_Init(10, 119, 60);
		  //
		  // Enable Timer (TIM14) for generate PWM (on PA4)
		  //
		  HAL_TIM_PWM_Start(&htim14, TIM_CHANNEL_1);
	  }

	  if (Val == 6)
	  {
		  printf(" ... New PWM frequency is 20 KHz (50%% duty cycle) \n\r");
		  OUR_TIM14_Init(9, 59, 30);
		  //
		  // Enable Timer (TIM14) for generate PWM (on PA4)
		  //
		  HAL_TIM_PWM_Start(&htim14, TIM_CHANNEL_1);
	  }

	  if (Val == 7)
	  {
		  printf(" ... New PWM frequency is 40 KHz (50%% duty cycle) \n\r");
		  OUR_TIM14_Init(4, 59, 30);
		  //
		  // Enable Timer (TIM14) for generate PWM (on PA4)
		  //
		  HAL_TIM_PWM_Start(&htim14, TIM_CHANNEL_1);
	  }
}

static void OUR_TIM14_Init(uint16_t Prescaler, uint16_t Period, uint16_t Pulse)
{

  /* USER CODE BEGIN TIM14_Init 0 */

  /* USER CODE END TIM14_Init 0 */

  TIM_OC_InitTypeDef sConfigOC = {0};

  /* USER CODE BEGIN TIM14_Init 1 */

  /* USER CODE END TIM14_Init 1 */
  htim14.Instance = TIM14;
  htim14.Init.Prescaler = Prescaler;
  htim14.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim14.Init.Period = Period;
  htim14.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim14.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_DISABLE;
  if (HAL_TIM_Base_Init(&htim14) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_TIM_PWM_Init(&htim14) != HAL_OK)
  {
    Error_Handler();
  }
  sConfigOC.OCMode = TIM_OCMODE_PWM1;
  sConfigOC.Pulse = Pulse;
  sConfigOC.OCPolarity = TIM_OCPOLARITY_HIGH;
  sConfigOC.OCFastMode = TIM_OCFAST_DISABLE;
  if (HAL_TIM_PWM_ConfigChannel(&htim14, &sConfigOC, TIM_CHANNEL_1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM14_Init 2 */

  /* USER CODE END TIM14_Init 2 */
  HAL_TIM_MspPostInit(&htim14);

}

//
// RX char from USART2 in Interrupt mode
//
void HAL_UART_RxCpltCallback(UART_HandleTypeDef *huart)
{
	RxData=TRUE;

	// Restart USART in Rx in Interrupt mode
	HAL_UART_Receive_IT(&huart2, CharDataBuffer, 1);
}

//
// Redirect printf on USART2
//
int __io_putchar(int ch)
{
 uint8_t c[1];
 c[0] = ch & 0x00FF;
 HAL_UART_Transmit(&huart2, &*c, 1, 10);
 return ch;
}

int _write(int file,char *ptr, int len)
{
 int DataIdx;
 for(DataIdx= 0; DataIdx< len; DataIdx++)
 {
 __io_putchar(*ptr++);
 }
return len;
}


/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
